#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-

from libervia.server.constants import Const as C
from sat.core.i18n import _
from twisted.internet import defer
from twisted.words.protocols.jabber import jid
from sat.tools.common import template_xmlui
from sat.tools.common import data_objects
from sat.core.log import getLogger
log = getLogger('pages/ticket')
"""ticket handling pages"""

name = u'merge-requests_list'
access = C.PAGES_ACCESS_PUBLIC
template = u"ticket/overview.html"


def parse_url(self, request):
    # check the service and node to use
    try:
        service = self.nextPath(request)
        node = self.nextPath(request)
    except IndexError:
        log.warning(_(u"missing service and node"))
        self.pageError(request, C.HTTP_BAD_REQUEST)

    if not service or service == u'@':
        service = u''

    if service:
        try:
            service = jid.JID(service)
        except Exception:
            log.warning(_(u"bad service entered: {}").format(service))
            self.pageError(request, C.HTTP_BAD_REQUEST)

    if not node or node == u'@':
        node = u''


    self.checkCache(request, C.CACHE_PUBSUB, service=service, node=node, short='merge-requests')

    data = self.getRData(request)
    data['service'] = service
    data['node'] = node

    template_data = request.template_data
    template_data[u'url_tickets_list'] = self.getPageByName('merge-requests_list').getURL(service.full(), node or u'@')
    template_data[u'url_tickets_new'] = self.getSubPageURL(request, 'merge-requests_new')

@defer.inlineCallbacks
def prepare_render(self, request):
    data = self.getRData(request)
    template_data = request.template_data
    service, node = data[u'service'], data[u'node']
    profile = self.getProfile(request) or C.SERVICE_PROFILE

    merge_requests = yield self.host.bridge.mergeRequestsGet(service.full() if service else u'', node, C.NO_LIMIT, [], '', {}, profile)
    template_data[u'tickets'] = [template_xmlui.create(self.host, x) for x in merge_requests[0]]
    template_data[u'on_ticket_click'] = data_objects.OnClick(url=self.getSubPageURL(request, 'merge-requests_view', '{item.id}'))
